Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 212305 - dev-lang/ghc-6.8.2 stops compiling on ppc64 (hangup)
Summary: dev-lang/ghc-6.8.2 stops compiling on ppc64 (hangup)
Status: RESOLVED WONTFIX
Alias: None
Product: Gentoo Linux
Classification: Unclassified
Component: Current packages (show other bugs)
Hardware: All Linux
: High normal with 1 vote (vote)
Assignee: Gentoo's Haskell Language team
URL:
Whiteboard:
Keywords:
Depends on:
Blocks: 206643
  Show dependency tree
 
Reported: 2008-03-04 19:09 UTC by Markus Rothe (RETIRED)
Modified: 2010-07-04 13:00 UTC (History)
2 users (show)

See Also:
Package list:
Runtime testing required: ---


Attachments
ghc strace from 6.6.1 (ghc-strace.txt,17.11 KB, text/plain)
2008-09-17 18:08 UTC, Markus Rothe (RETIRED)
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Markus Rothe (RETIRED) gentoo-dev 2008-03-04 19:09:02 UTC
While testing ghc-6.8.2 with gcc 3.4 I ran into the following problem:

------------------------------------------------------------------------
== make all -r;
 in /var/tmp/portage/dev-lang/ghc-6.8.2/work/ghc-6.8.2/rts
------------------------------------------------------------------------
../compiler/ghc-inplace -optc-O -optc-O2 -optc-pipe -optc-Wa,--noexecstack -optc-Wall -optc-W -optc-Wstrict-prototypes -optc-Wmissing-prototypes -optc-Wmissing-declarations -optc-Winline -optc-Waggregate-return -optc-I../includes -optc-I. -optc-Iparallel -optc-Ism -optc-DCOMPILING_RTS -optc-fomit-frame-pointer -optc-DNOSMP -optc-I../gmp/gmpbuild -optc-fno-strict-aliasing -H16m -O -opta-Wa,--noexecstack -w -optc-O2 -package-name rts -optc-DNOSMP -static -I../gmp/gmpbuild -I. -#include HCIncludes.h -dcmm-lint     -c Adjustor.c -o Adjustor.o


And that's it. It sits there for at least 4 hours. The process does not use any cpu. I'm lost what this could cause...


Portage 2.1.4.4 (default-linux/ppc/ppc64/2006.1/64bit-userland, gcc-3.4.6, glibc-2.3.6-r4, 2.6.23.16 ppc64)
=================================================================
System uname: 2.6.23.16 ppc64 unknown
Timestamp of tree: Tue, 04 Mar 2008 07:30:01 +0000
app-shells/bash:     3.2_p17-r1
dev-lang/python:     2.4.3-r1
dev-python/pycrypto: 2.0.1-r6
sys-apps/baselayout: 1.12.1
sys-apps/sandbox:    1.2.18.1-r2
sys-devel/autoconf:  2.13, 2.61-r1
sys-devel/automake:  1.4_p6, 1.5, 1.6.3, 1.7.9-r1, 1.8.5-r3, 1.9.6-r2, 1.10
sys-devel/binutils:  2.18-r1
sys-devel/gcc-config: 1.3.13-r3
sys-devel/libtool:   1.5.22
virtual/os-headers:  2.6.11-r4
ACCEPT_KEYWORDS="ppc64"
CBUILD="powerpc64-unknown-linux-gnu"
CFLAGS="-O2 -pipe"
CHOST="powerpc64-unknown-linux-gnu"
CONFIG_PROTECT="/etc /usr/kde/3.5/env /usr/kde/3.5/share/config /usr/kde/3.5/shutdown /usr/kde/4.0/env /usr/kde/4.0/share/config /usr/kde/4.0/shutdown /usr/share/config"
CONFIG_PROTECT_MASK="/etc/env.d /etc/gconf /etc/terminfo"
CXXFLAGS="-O2 -pipe"
DISTDIR="/usr/portage/distfiles"
FEATURES="autoconfig distlocks metadata-transfer sandbox sfperms strict unmerge-orphans userfetch"
GENTOO_MIRRORS="http://distfiles.gentoo.org http://distro.ibiblio.org/pub/linux/distributions/gentoo"
LANG="en_US.UTF-8"
LC_ALL="en_US.UTF-8"
PKGDIR="/usr/portage/packages"
PORTAGE_RSYNC_OPTS="--recursive --links --safe-links --perms --times --compress --force --whole-file --delete --stats --timeout=180 --exclude=/distfiles --exclude=/local --exclude=/packages"
PORTAGE_TMPDIR="/var/tmp"
PORTDIR="/usr/portage"
SYNC="rsync://rsync.gentoo.org/gentoo-portage"
USE="X alsa apache2 apm arts berkdb bitmap-fonts cli cracklib crypt cups dri eds emboss encode esd foomaticdb fortran gdbm gif gnome gpm gstreamer gtk ibm iconv imlib ipv6 isdnlog jpeg kde libwww mad midi mikmod motif mp3 mpeg mudflap ncurses nls nptl ogg opengl openmp oss pam pcre perl png ppc64 pppd python qt3 qt4 quicktime readline reflection sdl session spell spl ssl tcpd truetype truetype-fonts type1-fonts unicode vorbis xml xorg xv zlib" ALSA_PCM_PLUGINS="adpcm alaw asym copy dmix dshare dsnoop empty extplug file hooks iec958 ioplug ladspa lfloat linear meter mulaw multi null plug rate route share shm softvol" APACHE2_MODULES="actions alias auth_basic authn_alias authn_anon authn_dbm authn_default authn_file authz_dbm authz_default authz_groupfile authz_host authz_owner authz_user autoindex cache dav dav_fs dav_lock deflate dir disk_cache env expires ext_filter file_cache filter headers include info log_config logio mem_cache mime mime_magic negotiation rewrite setenvif speling status unique_id userdir usertrack vhost_alias" ELIBC="glibc" INPUT_DEVICES="keyboard mouse evdev" KERNEL="linux" LCD_DEVICES="bayrad cfontz cfontz633 glk hd44780 lb216 lcdm001 mtxorb ncurses text" USERLAND="GNU" VIDEO_CARDS="dummy fbdev mach64 mga nv r128 radeon sisusb v4l"
Unset:  CPPFLAGS, CTARGET, EMERGE_DEFAULT_OPTS, INSTALL_MASK, LDFLAGS, LINGUAS, MAKEOPTS, PORTAGE_COMPRESS, PORTAGE_COMPRESS_FLAGS, PORTAGE_RSYNC_EXTRA_OPTS, PORTDIR_OVERLAY
Comment 1 Markus Rothe (RETIRED) gentoo-dev 2008-09-17 18:08:48 UTC
Created attachment 165663 [details]
ghc strace from 6.6.1

I started a build again (now with gcc-4.3.1 and ghc-6.6.1, because this is a version you can do a bootstrap build with) and the build halts at the same moment.

this is the strace coming from ghc.
Comment 2 Andrew John Hughes 2008-10-07 12:36:37 UTC
Build also stops here on autoAdjuster with gcc 4.1:

== make all -r --jobserver-fds=3,4 -j;
 in /var/tmp/portage/dev-lang/ghc-6.8.2/work/ghc-6.8.2/rts
------------------------------------------------------------------------
../compiler/ghc-inplace -optc-O -optc-O2 -optc-mtune=G5 -optc-mcpu=G5 -optc-mabi=altivec -optc-pipe -optc-ggdb -optc-Wa,--noexecstack -optc-Wall -optc-W -optc-Wstrict-prototypes -optc-Wmissing-prototypes -optc-Wmissing-declarations -optc-Winline -optc-Waggregate-return -optc-I../includes -optc-I. -optc-Iparallel -optc-Ism -optc-DCOMPILING_RTS -optc-fomit-frame-pointer -optc-DNOSMP -optc-I../gmp/gmpbuild -optc-fno-strict-aliasing -H16m -O -optc-mtune=G5 -opta-mtune=G5 -optc-mcpu=G5 -opta-mcpu=G5 -optc-mabi=altivec -opta-mabi=altivec -opta-Wa,--noexecstack -w -optc-O2 -package-name rts -optc-DNOSMP -static -I../gmp/gmpbuild -I. -#include HCIncludes.h -dcmm-lint     -c Adjustor.c -o Adjustor.o
../compiler/ghc-inplace -optc-O -optc-O2 -optc-mtune=G5 -optc-mcpu=G5 -optc-mabi=altivec -optc-pipe -optc-ggdb -optc-Wa,--noexecstack -optc-Wall -optc-W -optc-Wstrict-prototypes -optc-Wmissing-prototypes -optc-Wmissing-declarations -optc-Winline -optc-Waggregate-return -optc-I../includes -optc-I. -optc-Iparallel -optc-Ism -optc-DCOMPILING_RTS -optc-fomit-frame-pointer -optc-DNOSMP -optc-I../gmp/gmpbuild -optc-fno-strict-aliasing -H16m -O -optc-mtune=G5 -opta-mtune=G5 -optc-mcpu=G5 -opta-mcpu=G5 -optc-mabi=altivec -opta-mabi=altivec -opta-Wa,--noexecstack -w -optc-O2 -package-name rts -optc-DNOSMP -static -I../gmp/gmpbuild -I. -#include HCIncludes.h -dcmm-lint     -c AdjustorAsm.S -o AdjustorAsm.o
../compiler/ghc-inplace -optc-O -optc-O2 -optc-mtune=G5 -optc-mcpu=G5 -optc-mabi=altivec -optc-pipe -optc-ggdb -optc-Wa,--noexecstack -optc-Wall -optc-W -optc-Wstrict-prototypes -optc-Wmissing-prototypes -optc-Wmissing-declarations -optc-Winline -optc-Waggregate-return -optc-I../includes -optc-I. -optc-Iparallel -optc-Ism -optc-DCOMPILING_RTS -optc-fomit-frame-pointer -optc-DNOSMP -optc-I../gmp/gmpbuild -optc-fno-strict-aliasing -H16m -O -optc-mtune=G5 -opta-mtune=G5 -optc-mcpu=G5 -opta-mcpu=G5 -optc-mabi=altivec -opta-mabi=altivec -opta-Wa,--noexecstack -w -optc-O2 -package-name rts -optc-DNOSMP -static -I../gmp/gmpbuild -I. -#include HCIncludes.h -dcmm-lint     -c Arena.c -o Arena.o
../compiler/ghc-inplace -optc-O -optc-O2 -optc-mtune=G5 -optc-mcpu=G5 -optc-mabi=altivec -optc-pipe -optc-ggdb -optc-Wa,--noexecstack -optc-Wall -optc-W -optc-Wstrict-prototypes -optc-Wmissing-prototypes -optc-Wmissing-declarations -optc-Winline -optc-Waggregate-return -optc-I../includes -optc-I. -optc-Iparallel -optc-Ism -optc-DCOMPILING_RTS -optc-fomit-frame-pointer -optc-DNOSMP -optc-I../gmp/gmpbuild -optc-fno-strict-aliasing -optc-w -H16m -O -optc-mtune=G5 -opta-mtune=G5 -optc-mcpu=G5 -opta-mcpu=G5 -optc-mabi=altivec -opta-mabi=altivec -opta-Wa,--noexecstack -w -optc-O2 -package-name rts -optc-DNOSMP -static -I../gmp/gmpbuild -I. -#include HCIncludes.h -dcmm-lint     -c Capability.c -o Capability.o
../compiler/ghc-inplace -optc-O -optc-O2 -optc-mtune=G5 -optc-mcpu=G5 -optc-mabi=altivec -optc-pipe -optc-ggdb -optc-Wa,--noexecstack -optc-Wall -optc-W -optc-Wstrict-prototypes -optc-Wmissing-prototypes -optc-Wmissing-declarations -optc-Winline -optc-Waggregate-return -optc-I../includes -optc-I. -optc-Iparallel -optc-Ism -optc-DCOMPILING_RTS -optc-fomit-frame-pointer -optc-DNOSMP -optc-I../gmp/gmpbuild -optc-fno-strict-aliasing -H16m -O -optc-mtune=G5 -opta-mtune=G5 -optc-mcpu=G5 -opta-mcpu=G5 -optc-mabi=altivec -opta-mabi=altivec -opta-Wa,--noexecstack -w -optc-O2 -package-name rts -optc-DNOSMP -static -I../gmp/gmpbuild -I. -#include HCIncludes.h -dcmm-lint     -c ClosureFlags.c -o ClosureFlags.o
ghc-6.8.2: fd:25769803776: lazyRead: invalid argument (Bad file descriptor)

ghc-6.8.2: fd:34359738368: lazyRead: invalid argument (Bad file descriptor)

ghc-6.8.2: fd:30064771072: lazyRead: invalid argument (Bad file descriptor)

ghc-6.8.2: fd:25769803776: lazyRead: invalid argument (Bad file descriptor)

make[1]: *** [AdjustorAsm.o] Error 1
make[1]: *** Deleting file `AdjustorAsm.o'
make[1]: *** Waiting for unfinished jobs....
make[1]: *** [ClosureFlags.o] Error 1
make[1]: *** [Arena.o] Error 1
make[1]: *** [Capability.o] Error 1

Portage 2.1.4.4 (default-linux/ppc/ppc64/2007.0/64bit-userland/970/pmac, gcc-4.1.2, glibc-2.7-r2, 2.6.24-gentoo-r3.omega ppc64)
=================================================================
System uname: 2.6.24-gentoo-r3.omega ppc64 PPC970MP, altivec supported
Timestamp of tree: Fri, 03 Oct 2008 11:45:01 +0000
distcc 2.18.3 powerpc64-unknown-linux-gnu (protocols 1 and 2) (default port 3632) [disabled]
ccache version 2.4 [enabled]
app-shells/bash:     3.2_p33
dev-java/java-config: 1.3.7, 2.1.6
dev-lang/python:     2.4.4-r13, 2.5.2-r7
dev-python/pycrypto: 2.0.1-r6
dev-util/ccache:     2.4-r7
sys-apps/baselayout: 1.12.11.1
sys-apps/sandbox:    1.2.18.1-r2
sys-devel/autoconf:  2.13, 2.61-r2
sys-devel/automake:  1.5, 1.6.3, 1.7.9-r1, 1.8.5-r3, 1.9.6-r2, 1.10.1-r1
sys-devel/binutils:  2.18-r3
sys-devel/gcc-config: 1.4.0-r4
sys-devel/libtool:   1.5.26
virtual/os-headers:  2.6.24
ACCEPT_KEYWORDS="ppc64"
CBUILD="powerpc64-unknown-linux-gnu"
CFLAGS="-O2 -mtune=G5 -mcpu=G5 -mabi=altivec -pipe -ggdb"
CHOST="powerpc64-unknown-linux-gnu"
CONFIG_PROTECT="/etc /usr/env /usr/kde/3.5/env /usr/kde/3.5/share/config /usr/kde/3.5/shutdown /usr/share/X11/xkb /usr/share/config /usr/shutdown"
CONFIG_PROTECT_MASK="/etc/ca-certificates.conf /etc/env.d /etc/env.d/java/ /etc/fonts/fonts.conf /etc/gconf /etc/revdep-rebuild /etc/terminfo /etc/texmf/web2c /etc/udev/rules.d"
CXXFLAGS="-O2 -mtune=G5 -mcpu=G5 -mabi=altivec -pipe -ggdb"
DISTDIR="/usr/portage/distfiles"
FEATURES="autoconfig ccache distlocks metadata-transfer parallel-fetch sandbox sfperms splitdebug strict unmerge-orphans userfetch"
GENTOO_MIRRORS="http://gentoo.blueyonder.co.uk ftp://mirrors.blueyonder.co.uk/mirrors/gentoo http://www.mirrorservice.org/sites/www.ibiblio.org/gentoo/ ftp://ftp.mirrorservice.org/sites/www.ibiblio.org/gentoo/ "
LANG="en_GB.UTF-8"
LINGUAS="en_GB"
MAKEOPTS="-j5"
PKGDIR="/usr/portage/packages"
PORTAGE_RSYNC_OPTS="--recursive --links --safe-links --perms --times --compress --force --whole-file --delete --stats --timeout=180 --exclude=/distfiles --exclude=/local --exclude=/packages"
PORTAGE_TMPDIR="/var/tmp"
PORTDIR="/usr/portage"
PORTDIR_OVERLAY="/usr/portage/local/layman/kde-testing /home/andrew/projects/gentoo/java-overlay /home/andrew/projects/gentoo/andys_overlay /home/andrew/projects/gentoo/java-experimental"
SYNC="rsync://rsync.europe.gentoo.org/gentoo-portage"
USE="X a52 aac acl addbookmarks alias alsa altivec asf autoreplace bash-completion berkdb bluetooth bzip2 cairo caps cdda cddb cdparanoia cdr cjk cli connectionstatus contactnotes cracklib crypt cups curl cvs daap dbus dga dia djvu dri dts dv dvd dvdnav dvdr dvdread dvi effects emacs emf encode examples fame ffmpeg fftw firefox flac fortran fping gcj gdbm gif git gmp gnutls gpac gpgme gpm gtk hal hfs highlight history iconv idn ieee1394 imagemagick imap imlib ipod ipv6 irc isdnlog jack java java5 javascript jingle jpeg jpeg2k kde ladspa lame lapack latex lcms ldap libnotify live lzo mad matroska mbox midi mjpeg mmap mng mp2 mp3 mpeg mplayer mudflap musepack musicbrainz ncurses netmeeting network nls nntp nowlistening nptl nptlonly nsplugin ogg openal openexr opengl openmp optimisememory oss pam pcre pdf perl plotutils png pnm pop postscript ppc64 ppds pppd python qt qt3 qt4 quicktime readline reflection rtc sasl sdl session shout slp smime smp sms smtp snmp sox speex spell spl sqlite ssl statistics stream subtitles subversion svg syslog t1lib tcpd tetex texteffect tga theora threads tiff translator truetype unicode usb v4l2 vcd visualization vorbis vram webpresence wmf x264 xanim xattr xchattext xcomposite xine xinerama xml xorg xscreensaver xv xvid xvmc yahoo zeroconf zlib" ALSA_PCM_PLUGINS="adpcm alaw asym copy dmix dshare dsnoop empty extplug file hooks iec958 ioplug ladspa lfloat linear meter mmap_emul mulaw multi null plug rate route share shm softvol" APACHE2_MODULES="actions alias auth_basic authn_alias authn_anon authn_dbm authn_default authn_file authz_dbm authz_default authz_groupfile authz_host authz_owner authz_user autoindex cache dav dav_fs dav_lock deflate dir disk_cache env expires ext_filter file_cache filter headers include info log_config logio mem_cache mime mime_magic negotiation rewrite setenvif speling status unique_id userdir usertrack vhost_alias" ELIBC="glibc" INPUT_DEVICES="keyboard mouse" KERNEL="linux" LCD_DEVICES="bayrad cfontz cfontz633 glk hd44780 lb216 lcdm001 mtxorb ncurses text" LINGUAS="en_GB" USERLAND="GNU" VIDEO_CARDS="nv fbdev"
Unset:  CPPFLAGS, CTARGET, EMERGE_DEFAULT_OPTS, FFLAGS, INSTALL_MASK, LC_ALL, LDFLAGS, PORTAGE_COMPRESS, PORTAGE_COMPRESS_FLAGS, PORTAGE_RSYNC_EXTRA_OPTS
Comment 3 Andrew John Hughes 2008-10-07 14:16:24 UTC
Same happens with gcc 4.3.1
Comment 4 Andrew John Hughes 2008-10-09 07:49:21 UTC
Same with 6.6 too :(
Comment 5 Santiago Gala 2008-11-10 15:03:04 UTC
I have a different failure:

(...)
../compiler/ghc-inplace -H16m -O -opta-Wa,--noexecstack -w -optc-O2 -package-name rts -static -I../gmp/gmpbuild -I. -#include HCIncludes.h -dcmm-lint     -c Apply.cmm -o Apply.o
<interno>:0:1: lexical error
make[1]: *** [Apply.o] Error 1
make: *** [stage1] Error 1
 * 
 * ERROR: dev-lang/ghc-6.8.2 failed.
 * Call stack:
 *               ebuild.sh, line   49:  Called src_compile
 *             environment, line 3156:  Called die
 * The specific snippet of code:
 *           emake all || die "make failed";
 *  The die message:
 *   make failed
 * 
 * If you need support, post the topmost build error, and the call stack if relevant.
 * A complete build log is located at '/var/tmp/portage/dev-lang/ghc-6.8.2/temp/build.log'.
 * The ebuild environment file is located at '/var/tmp/portage/dev-lang/ghc-6.8.2/temp/environment'.
 * 

 * Messages for package dev-lang/ghc-6.8.2:

 * 
 * ERROR: dev-lang/ghc-6.8.2 failed.
 * Call stack:
 *               ebuild.sh, line   49:  Called src_compile
 *             environment, line 3156:  Called die
 * The specific snippet of code:
 *           emake all || die "make failed";
 *  The die message:
 *   make failed
 * 
 * If you need support, post the topmost build error, and the call stack if relevant.
 * A complete build log is located at '/var/tmp/portage/dev-lang/ghc-6.8.2/temp/build.log'.
 * The ebuild environment file is located at '/var/tmp/portage/dev-lang/ghc-6.8.2/temp/environment'.
 * 
Comment 6 Francisco Lloret 2008-12-06 12:02:10 UTC
I get a similar error:

* Messages for package dev-lang/ghc-6.8.2:

 * 
 * ERROR: dev-lang/ghc-6.8.2 failed.
 * Call stack:
 *               ebuild.sh, line   49:  Called src_compile
 *             environment, line 3201:  Called die
 * The specific snippet of code:
 *           emake all || die "make failed";
 *  The die message:
 *   make failed
 * 
 * If you need support, post the topmost build error, and the call stack if relevant.
 * A complete build log is located at '/var/tmp/portage/dev-lang/ghc-6.8.2/temp/build.log'.
 * The ebuild environment file is located at '/var/tmp/portage/dev-lang/ghc-6.8.2/temp/environment'.
 * 

Version 6.6.1 has the same problem, as related in bug 202212. The same workaround also works with this version.

Comment 7 Santiago Gala 2008-12-14 09:44:52 UTC
"LC_ALL=C emerge ghc" makes it work...
Comment 8 Tom Gall (RETIRED) gentoo-dev 2009-07-05 20:23:13 UTC
when I attempt to build I see the following :

Warning: retaining unknown function `.L.__stginit_CompatziRawSystem_' in output from C compiler
Warning: retaining unknown function `.L.__stginit_CompatziRawSystem' in output from C compiler
Prologue junk?: 	.type	__stginit_CompatziRawSystem_, @function
.L.__stginit_CompatziRawSystem_:
 # 13 "/var/tmp/portage/dev-lang/ghc-6.4.2/temp/ghc4169.hc" 1

Warning: retaining unknown function `.L.__stginit_DistributionziCompatziReadP_' in output from C compiler
Warning: retaining unknown function `.L.__stginit_DistributionziCompatziReadP' in output from C compiler
Prologue junk?: 	.type	__stginit_DistributionziCompatziReadP_, @function
.L.__stginit_DistributionziCompatziReadP_:
 # 13 "/var/tmp/portage/dev-lang/ghc-6.4.2/temp/ghc4171.hc" 1

<<ghc: 52994904 bytes, 12 GCs, 2601509/5502696 avg/max bytes residency (3 samples), 20M in use, 0.00 INIT (0.00 elapsed), 0.22 MUT (0.98 elapsed), 0.13 GC (0.45 elapsed) :ghc>>
make[4]: *** [Compat/RawSystem.o] Error 255
make[4]: *** Waiting for unfinished jobs....
<<ghc: 54346752 bytes, 12 GCs, 2496906/5137960 avg/max bytes residency (3 samples), 20M in use, 0.00 INIT (0.

Looks like someone is more or less passing crap to the assembler.

going to try setting LC_ALL=C .. which is odd since that shoudl be the default locale.
Comment 9 Sergei Trofimovich gentoo-dev 2009-08-30 19:09:19 UTC
(In reply to comment #0)
> While testing ghc-6.8.2 with gcc 3.4 I ran into the following problem:
> And that's it. It sits there for at least 4 hours. The process does not use any
> cpu. I'm lost what this could cause...
> 
It's a problem of ghc-6.4.2 binary (and source) build. It dislikes big-endian 64 bit platforms. I just pushed patches for ghc-6.4.2-r1 and ghc-6.6.1-r1 BE64 fixes and rebuilt them successfully (ghc-6.4.2 requires older gcc):
http://code.haskell.org/~slyfox/ghc-ppc64/unregisterised-nodoc/
However, those are not exact binary builds we use in gentoo: there is not documentation.

The one build I've done properly is ghc-6.10.4 in overlay: http://code.haskell.org/gentoo/gentoo-haskell/dev-lang/ghc/ghc-6.10.4.ebuild . Testing is greatly appreciated.
Thanks!
Comment 10 Francisco Lloret 2009-09-11 18:21:15 UTC
Error compiling dev-lang/ghc-6.8.2-r1:
...
...
pbuild -I. -#include HCIncludes.h -dcmm-lint     -c sm/Scav.c -o sm/Scav.o
../compiler/ghc-inplace -optc-O -optc-march=core2 -optc-O2 -optc-pipe -optc-Wa,--noexecstack -optc-Wall -optc-W -optc-Wstrict-prototypes -optc-Wmissing-prototypes -optc-Wmissing-declarations -optc-Winline -optc-Waggregate-return -optc-I../includes -optc-I. -optc-Iparallel -optc-Ism -optc-DCOMPILING_RTS -optc-fomit-frame-pointer -optc-I../gmp/gmpbuild -optc-fno-strict-aliasing -H16m -O -optc-march=core2 -opta-march=core2 -opta-Wa,--noexecstack -w -optc-O2 -package-name rts -static -I../gmp/gmpbuild -I. -#include HCIncludes.h -dcmm-lint     -c sm/Storage.c -o sm/Storage.o
../compiler/ghc-inplace -H16m -O -optc-march=core2 -opta-march=core2 -opta-Wa,--noexecstack -w -optc-O2 -package-name rts -static -I../gmp/gmpbuild -I. -#include HCIncludes.h -dcmm-lint     -c Apply.cmm -o Apply.o
<interno>:0:1: lexical error
make[1]: *** [Apply.o] Error 1
make[1]: *** Se espera a que terminen otras tareas....
sm/Scav.c: En la función ‘scavenge_mark_stack’:

sm/Scav.c:66:0:
     aviso: falló la inclusión en línea en la llamada a ‘scavenge_srt’: call is unlikely and code size would grow

sm/Scav.c:123:0:  aviso: llamado desde aquí

sm/Scav.c:66:0:
     aviso: falló la inclusión en línea en la llamada a ‘scavenge_srt’: call is unlikely and code size would grow

sm/Scav.c:112:0:  aviso: llamado desde aquí

sm/Scav.c:66:0:
     aviso: falló la inclusión en línea en la llamada a ‘scavenge
...
...
...
>>> Failed to emerge dev-lang/ghc-6.8.2-r1, Log file:

>>>  '/var/tmp/portage/dev-lang/ghc-6.8.2-r1/temp/build.log'

 * Messages for package dev-lang/ghc-6.8.2-r1:

 * 
 * ERROR: dev-lang/ghc-6.8.2-r1 failed.
 * Call stack:
 *               ebuild.sh, line   49:  Called src_compile
 *             environment, line 3411:  Called die
 * The specific snippet of code:
 *       emake all || die "make failed"
 *  The die message:
 *   make failed
 * 
 * If you need support, post the topmost build error, and the call stack if relevant.
 * A complete build log is located at '/var/tmp/portage/dev-lang/ghc-6.8.2-r1/temp/build.log'.
 * The ebuild environment file is located at '/var/tmp/portage/dev-lang/ghc-6.8.2-r1/temp/environment'.
 * 
Comment 11 Sergei Trofimovich gentoo-dev 2009-09-12 13:38:08 UTC
> pbuild -I. -#include HCIncludes.h -dcmm-lint     -c sm/Scav.c -o sm/Scav.o
> ../compiler/ghc-inplace -optc-O -optc-march=core2 -optc-O2 -optc-pipe
> -optc-Wa,--noexecstack -optc-Wall -optc-W -optc-Wstrict-prototypes
> -optc-Wmissing-prototypes -optc-Wmissing-declarations -optc-Winline
> -optc-Waggregate-return -optc-I../includes -optc-I. -optc-Iparallel -optc-Ism
> -optc-DCOMPILING_RTS -optc-fomit-frame-pointer -optc-I../gmp/gmpbuild
> -optc-fno-strict-aliasing -H16m -O -optc-march=core2 -opta-march=core2
> -opta-Wa,--noexecstack -w -optc-O2 -package-name rts -static -I../gmp/gmpbuild
> -I. -#include HCIncludes.h -dcmm-lint     -c sm/Storage.c -o sm/Storage.o
> ../compiler/ghc-inplace -H16m -O -optc-march=core2 -opta-march=core2
> -opta-Wa,--noexecstack -w -optc-O2 -package-name rts -static -I../gmp/gmpbuild
> -I. -#include HCIncludes.h -dcmm-lint     -c Apply.cmm -o Apply.o
> <interno>:0:1: lexical error

It seems to be known separate bug when LANG envvar for root user is not "C".
May I ask you to search it on bugzilla or report new one?
'LANG=C emerge ...' may be used as a workaround currently.
Comment 12 Sergei Trofimovich gentoo-dev 2009-09-12 13:39:47 UTC
(In reply to comment #11)
> > pbuild -I. -#include HCIncludes.h -dcmm-lint     -c sm/Scav.c -o sm/Scav.o
> > ../compiler/ghc-inplace -optc-O -optc-march=core2 -optc-O2 -optc-pipe
> > -optc-Wa,--noexecstack -optc-Wall -optc-W -optc-Wstrict-prototypes
> > -optc-Wmissing-prototypes -optc-Wmissing-declarations -optc-Winline
> > -optc-Waggregate-return -optc-I../includes -optc-I. -optc-Iparallel -optc-Ism
> > -optc-DCOMPILING_RTS -optc-fomit-frame-pointer -optc-I../gmp/gmpbuild
> > -optc-fno-strict-aliasing -H16m -O -optc-march=core2 -opta-march=core2
> > -opta-Wa,--noexecstack -w -optc-O2 -package-name rts -static -I../gmp/gmpbuild
> > -I. -#include HCIncludes.h -dcmm-lint     -c sm/Storage.c -o sm/Storage.o
> > ../compiler/ghc-inplace -H16m -O -optc-march=core2 -opta-march=core2
> > -opta-Wa,--noexecstack -w -optc-O2 -package-name rts -static -I../gmp/gmpbuild
> > -I. -#include HCIncludes.h -dcmm-lint     -c Apply.cmm -o Apply.o
> > <interno>:0:1: lexical error
> 
> It seems to be known separate bug when LANG envvar for root user is not "C".
> May I ask you to search it on bugzilla or report new one?
> 'LANG=C emerge ...' may be used as a workaround currently.
> 

Oh, sorry. I even have ot bookmarked.
Please, paste your root's 'locale' output there -> http://bugs.gentoo.org/show_bug.cgi?id=202212
Comment 13 Sergei Trofimovich gentoo-dev 2010-07-04 13:00:30 UTC
I see quite a lot of ppc64 unrelated (seem to-be-fixed bugs) here in comments.
Please, open new bugs if they are still relevant.

Shortened subject to "dev-lang/ghc-6.8.2 stops compiling on ppc64 (hangup)".

Closed as WONTFIX.

ghc-6.10.x and ghc-6.12.x (both are ~ppc64 in tree) should behave fine